/*
 * $Id: $
 *
 * Module:  apr_arch_file_io_snippet -- description
 * Created: 06-OCT-2009 17:11
 * Author:  tmr
 */

/*
 * A snippet of httpd-2.2.13/srclib/apr/include/arch/unix/apr_arch_file_io.h
 */

#ifndef _APR_ARCH_FILE_IO_SNIPPET_H_
#define _APR_ARCH_FILE_IO_SNIPPET_H_

struct apr_file_t {
    apr_pool_t *pool;
    int filedes;
    char *fname;
    apr_int32_t flags;
    int eof_hit;
    int is_pipe;
    apr_interval_time_t timeout;
    int buffered;
    enum {BLK_UNKNOWN, BLK_OFF, BLK_ON } blocking;
    int ungetchar;    /* Last char provided by an unget op. (-1 = no char)*/
#ifndef WAITIO_USES_POLL
    /* if there is a timeout set, then this pollset is used */
    apr_pollset_t *pollset;
#endif
    /* Stuff for buffered mode */
    char *buffer;
    apr_size_t bufpos;        /* Read/Write position in buffer */
    apr_size_t bufsize;       /* The size of the buffer */
    unsigned long dataRead;   /* amount of valid data read into buffer */
    int direction;            /* buffer being used for 0 = read, 1 = write */
    apr_off_t filePtr;        /* position in file of handle */
#if APR_HAS_THREADS
    struct apr_thread_mutex_t *thlock;
#endif
};


#endif

// vim: fdm=syntax:fdn=1:tw=74:ts=2:syn=c
